	LIST p = 16F628
	INCLUDE "p16F628.inc"
	
	errorlevel -302
	
#define TEST	0
	
;/*******  Xtal = 11,059MHz  RS232 = 9600 Bauds  **********/	
Same	equ 	1
#define ZERO	STATUS, Z
#define Report	STATUS, C


InBuf		equ	0x40	; jusqu' 0x60, soit 32 octets
Horloge		equ	0x60

Secondes	equ	0x62

L_num		equ	0x65	; longueur totale du numro
mem_Cpt1	equ	0x66	; les mmoires de paramtres
mem_tmr0	equ	0x67	; de l'mission du DTMF
mem_ton		equ	0x68	;
Cpt3		equ	0x69	; compteur de tops pour l'emission DTMF
; variables interrupt	; aprs 0x70 parce qu'elles sont accessibles de toutes les banks
W_Temp		equ	0x70
Stat_Temp	equ	0x71
PStatus		equ	0x72
Temp_int	equ	0x73

#define TON1		PORTA, 1
#define top_dtmf	PStatus, 0	;  1 on met,  0 silence
#define vu_sec		PStatus, 1	; une seconde viens de passer
#define vu_min		PStatus, 2	; une minute de passe
#define flag_comp	PStatus, 3	; composition de numro en cours
	ORG	0	
	goto	Debut

	ORG	4
	goto	interrupt

Debut:
	clrf	INTCON		; aucune interruption
	movlw	0x07
	movwf	CMCON		; portA en IO digital
	banksel	TRISA
	movlw	0xFC		; A0 et 1 en sortie
	movwf	TRISA		; le reste en entre
	movlw	0x03
	movwf	TRISB		; 0 et 1, en entre
	movlw	0x8A		; pas de R sur B, WDT : 1/4
	movwf	OPTION_REG
	banksel PORTB
	movlw	0xFF
	movwf	PORTA
	bcf	INTCON, T0IE	; timer 0, TON1, arrt
			
;/***  Gnrateur de TON2 / Tonalit d'attente ****/	
	bcf	T2CON, T2CKPS0
	bsf	T2CON, T2CKPS1	; prescaler = 16
; PR2 = (PWM / (4 * Tosc * Prescaler) )	 - 1
; PWM = 748,5s = 748500ns (1336Hz), Tosc = 90,4ns
; PR2 = (748500 / 361.67 * 4 * 16 ) - 1 = 128,37
	bsf	STATUS, RP0		; page 1
	movlw	0xF0		; tonalit d'attente
	movwf	PR2
	bcf	STATUS, RP0
	movlw	0x78
	movwf	CCPR1L			; duty cycle = 50%

	bcf	CCP1CON, 5
	bcf	CCP1CON, 4
	bsf	CCP1CON, 3		; PWM mode sur CCP1
	bsf	CCP1CON, 2

	
	bsf	T2CON, TMR2ON	; autorise le timer 2, gnre la tonalit d'attente
;/*****  USART  *****/
	bsf	STATUS, RP0
	clrf	TXSTA
	bsf	TXSTA, BRGH
;/ x+1 = Fosc / (16 * Bd);  x = (Fosc / (16 * Bd)) - 1  = 64
	movlw	.71
	movwf	SPBRG		; diviseur de baud rate	
	bsf	PIE1, RCIE	; autorise l'int USART
	bcf	STATUS, RP0
	movlw	0x90
	movwf	RCSTA		; CREN et SPEN
	bsf	INTCON, PEIE	; periph int	
	
	bsf	INTCON, GIE
	clrf	MStatus
	clrf	PStatus
	btfss	STATUS, 4	; TO\
	goto	no_del		; suite  wdt, pas de dlai
#if !TEST	
	movlw	0x20
	movwf	Count
binit:
	call	DelayL
	decfsz	Count, Same
	goto	binit	
#endif
no_del:
;/*****  Timer 1 *** gnre l'horloge 1 seconde *****/
	movlw	0x00		; prescaler = 0, tmr1 off
	movwf	T1CON
	banksel	PIE1
	bsf	PIE1, TMR1IE	; autorise l'interruption TMR1
	banksel	PORTB
	bsf	T1CON, TMR1ON	; autorise le timer1
	clrf	Secondes
	movlw	1
	movwf	Horloge
	goto	deb

deb:
	;boucle du programme principal
	goto	debut

	
;/**************************  composition ******************************/	

deb_comp:	
	movlw	InBuf		; le dbut du buffer contenant le numro
	movwf	FSR
	btfsc	top_dtmf
	goto	$-1		; attend la descente du flag
	btfss	top_dtmf	; attend la monte
	goto	$-1		; pour commencer toujours pareil
b_comp:
	btfss	top_dtmf	; attend la remonte
	goto	$-1		; pour commencer toujours pareil
	movfw	INDF
	incf	FSR, Same
	movwf	Tempo	
	call	table_ton	; retourne la composition du DTMF
	movwf	mem_ton		; save
	andlw	0x03
	movwf	Tempo
	call	table_pwm	; valeur du compteur
	movwf	Tempo
	banksel	PR2
	movwf	PR2		; met en place	
	banksel	Tempo
	rrf	Tempo, W
	movwf	CCPR1L
; TMR0 donne TON1	
	swapf	mem_ton, W
	andlw	0x03
	movwf	Tempo
	call	table_tmr0_1	; valeur du compteur
	movwf	mem_Cpt1
	
	call	table_tmr0_2	; Tempo est toujours le mme. 
	movwf	mem_tmr0	; la valeur du registre
;/****  mettre en route le timer et la gnration du DTMF
	
	bsf	T2CON, TMR2ON
	bsf	INTCON, T0IE	; dmarre les gnrateurs
	btfsc	top_dtmf	
	goto	$-1		; attend la fin du creneau	
	bcf	T2CON, TMR2ON
	bcf	INTCON, T0IE	; coupe les gnrateurs
	decfsz	L_num, Same	; dcompte le chiffre
	goto	b_comp		; chiffre suivant

	return


;/********************************  interruption ***************************/

interrupt:

	movwf	W_Temp		; save W
	swapf	STATUS, W
	movwf	Stat_Temp	; save STATUS
	movfw	FSR
	movwf	FSR_Temp	; save FSR	
	btfsc	INTCON, T0IF	; timer 0	
	goto	Tmr0_int
	btfsc	PIR1, RCIF
	goto	RS_int
	btfsc	PIR1, TMR1IF
	goto	Tmr1_int
	goto	ret_int
Tmr0_int:
	btfss	INTCON, T0IE	; si pas autoris
	goto	fin_tmr0	; permet de vider le flag
	decfsz	Cpt1, Same
	goto	pas_fini
	
	btfsc	TON1
	goto	L1
	bsf	TON1
	goto	L2
L1:
	bcf	TON1
L2:		
	movfw	mem_Cpt1	; valeur releve dans la table
	movwf	Cpt1
pas_fini:		; pas arriv  0	
	movfw	mem_tmr0	; valeur releve dans la table
	movwf	TMR0
	goto	fin_tmr0		
fini:	
	movfw	mem_tmr0	; valeur releve dans la table
	movwf	TMR0
fin_tmr0:	
	bcf	INTCON, T0IF
	goto	ret_int
;**** interrupt par TMR1  *****
; compte 1 seconde, et incrmente le registre Secondes
Tmr1_int:		; fabrique aussi le crneau d'mission DTMF
	clrwdt	
	movlw	.19
	subwf	Horloge, W
	btfsc	ZERO
	bsf	top_dtmf	; dbut du temps d'mission
	decfsz	Horloge, Same
	goto	t1_0
	goto	vu_1s		; on a vu 1 seconde
t1_0:	
	bcf	PIR1, TMR1IF
	goto	ret_int
vu_1s:
	bsf	vu_sec		; signale une seconde (bcf dans com_en_cours)
	incf	Secondes, Same
	movlw	0x2A		; 42
	movwf	Horloge
	bcf	top_dtmf	; fin du temps d'mission
	movlw	0x3C
	subwf	Secondes, W
	btfss	ZERO
	goto	t1_0
	clrf	Secondes
	bsf	vu_min		; pour demander l'affichage du temps restant
	goto	t1_0		; sera remis  0 par com_en_cours
;**** interrupt sur RS232 *****
RS_int:
	; programme de l'int RS
fin_intRS:	
	bcf	PIR1, RCIF
	goto	ret_int
ret_int:			; restore les registres
	movfw	FSR_Temp
	movwf	FSR
	swapf	Stat_Temp, W
	movwf	STATUS
	swapf	W_Temp, Same
	swapf	W_Temp, W
	retfie
	
	
;/*****************************************************************/
	ORG	0x600
;/******************************** table_ton ***********************/
table_ton:
	movlw	HIGH(table_ton)
	movwf	PCLATH
	movfw	Tempo
	andlw	0x0F
	addwf	PCL, Same
	retlw	0x31		; 0 = 941 + 1336
	retlw	0x00		; 1 = 697 + 1209
	retlw	0x01		; 2 = 697 + 1336
	retlw	0x02		; 3 = 697 + 1477
	retlw	0x10		; 4 = 770 + 1209
	retlw	0x11		; 5 = 770 + 1336
	retlw	0x12		; 6 = 770 + 1477
	retlw	0x20		; 7 = 852 + 1209
	retlw	0x21		; 8 = 852 + 1336
	retlw	0x22		; 9 = 852 + 1477
	retlw	0x30		; * = 941 + 1209  (au cas o)
	retlw	0x32		; # = 941 + 1477
	retlw	0
	retlw	0
	retlw	0
	retlw	0
	
table_tmr0_1:
	movlw	HIGH(table_tmr0_1)
	movwf	PCLATH
	movfw	Tempo
	addwf	PCL, Same
	retlw	9 ;8
	retlw	8 ;8
	retlw	8 ;7
	retlw	7 ;6
	
table_tmr0_2:
	movlw	HIGH(table_tmr0_2)
	movwf	PCLATH
	movfw	Tempo
	addwf	PCL, Same
	retlw	0x39	; 697 8
	retlw	0x35	; 0x4B	; 770 8
	retlw	0x4B	;0x44	; 852 7
	retlw	0x44	;0x38	; 941 6
	
table_pwm:
	movlw	HIGH(table_pwm)
	movwf	PCLATH
	movfw	Tempo
	addwf	PCL, Same
	retlw	0x8F	;0x69	; 1211
	retlw	0x80	;0x74	; 1336
	retlw	0x74	; x80	; 1477
	retlw	0xE0		; tonalit d'attente	
